/*	$NetBSD$	*/

/*-
 * Copyright (c) 2013 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Taylor R. Campbell.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * awk '$1 == "#define" && $2 ~ /^AF_[A-Z0-9_]*$/ && $3 ~ /^[0-9]*$/ { printf("\t[%s] = \"%s\",\n", $2, tolower(substr($2, 4))); }' < sys/socket.h
 */

static const char *const address_families[] = {
	[AF_UNSPEC] = "unspec",
	[AF_LOCAL] = "local",
	[AF_INET] = "inet",
	[AF_IMPLINK] = "implink",
	[AF_PUP] = "pup",
	[AF_CHAOS] = "chaos",
	[AF_NS] = "ns",
	[AF_ISO] = "iso",
	[AF_ECMA] = "ecma",
	[AF_DATAKIT] = "datakit",
	[AF_CCITT] = "ccitt",
	[AF_SNA] = "sna",
	[AF_DLI] = "dli",
	[AF_LAT] = "lat",
	[AF_HYLINK] = "hylink",
	[AF_APPLETALK] = "appletalk",
	[AF_OROUTE] = "oroute",
	[AF_LINK] = "link",
	[AF_COIP] = "coip",
	[AF_CNT] = "cnt",
	[AF_IPX] = "ipx",
	[AF_INET6] = "inet6",
	[AF_ISDN] = "isdn",
	[AF_NATM] = "natm",
	[AF_ARP] = "arp",
	[AF_BLUETOOTH] = "bluetooth",
	[AF_IEEE80211] = "ieee80211",
	[AF_MPLS] = "mpls",
	[AF_ROUTE] = "route",
	[AF_MAX] = "max",
};

/*
 * awk '$1 == "#define" && $2 ~ /^SOCK_[A-Z_]*$/ && $3 ~ /^[0-9]*$/ { printf("\t[%s] = \"%s\",\n", $2, tolower(substr($2, 6))); }' < sys/socket.h
 */

static const char *const socket_types[] = {
	[SOCK_STREAM] = "stream",
	[SOCK_DGRAM] = "dgram",
	[SOCK_RAW] = "raw",
	[SOCK_RDM] = "rdm",
	[SOCK_SEQPACKET] = "seqpacket",
};
